/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.6 by edhill, Fri Sep 5 00:25:42 2003 UTC revision 1.14 by edhill, Tue Oct 21 15:29:20 2003 UTC
# Line 8  Line 8 
8  #   modified by aja 01/00  #   modified by aja 01/00
9  #   rewritten in bash by eh3 08/03  #   rewritten in bash by eh3 08/03
10    
11    # Search for particular CPP #cmds associated with packages
12    # usage: test_for_package_in_cpp_options CPP_file package_name
13    test_for_package_in_cpp_options() {
14        cpp_options=$1
15        pkg=$2
16        grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1
17        RETVAL=$?
18        if test "x${RETVAL}" = x0 ; then
19            echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"
20            exit 99
21        fi
22        grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1
23        RETVAL=$?
24        if test "x${RETVAL}" = x0 ; then
25            echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"
26            exit 99
27        fi
28        grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1
29        RETVAL=$?
30        if test "x${RETVAL}" = x0 ; then
31            echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"
32            exit 99
33        fi
34        grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1
35        RETVAL=$?
36        if test "x${RETVAL}" = x0 ; then
37            echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"
38            exit 99
39       fi
40    }
41    
42    # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
43    # the package list.
44    expand_pkg_groups() {
45        new_packages=
46        PKG_GROUPS=$ROOTDIR"/pkg/pkg_groups"
47        if test -r $PKG_GROUPS ; then
48            cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp
49            cat ./p1.tmp | awk '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp
50            matched=0
51            for i in $PACKAGES ; do
52                line=`grep "^ *$i" ./p2.tmp`
53                RETVAL=$?
54                if test "x$RETVAL" = x0 ; then
55                    matched=1
56                    replace=`echo $line | awk '{ $1=""; $2=""; print $0 }'`
57                    echo "    replacing \"$i\" with: $replace"
58                    new_packages="$new_packages $replace"
59                else
60                    new_packages="$new_packages $i"
61                fi
62            done
63            PACKAGES=$new_packages
64            rm -f ./p[1,2].tmp
65        else
66            echo "Warning: can't read package groups definition file: $PKG_GROUPS"
67        fi
68    }
69    
70  # Guess possible config options for this host  # Guess possible config options for this host
71  find_possible_configs()  {  find_possible_configs()  {
72    
73      p_PLATFORM=`uname`"-"`uname -m`      tmp1=`uname`"_"`uname -m`
74      echo "The platform appears to be:"      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
75      echo "  "$p_PLATFORM      PLATFORM=`echo $tmp2 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
76        OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
77      p_LN=      echo "  The platform appears to be:  $PLATFORM"
78    #     if test "x$OFLIST" = x ; then
79    #       echo "  No pre-defined options files were found matching this platform"
80    #       echo "  but examples for other platforms can be found in:"
81    #       echo "    $ROOTDIR/tools/build_options"
82    #     else
83    #       echo "  Options files (located in $ROOTDIR/tools/build_options) that"
84    #       echo "  may work with this machine are:"
85    #       for i in $OFLIST ; do
86    #           echo "    $i"
87    #       done
88    #     fi
89        
90      echo "test" > test      echo "test" > test
91      ln -s ./test link      ln -s ./test link
92      RETVAL=$?      RETVAL=$?
93      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
94          p_LN="ln -s"          LN="ln -s"
95        else
96            echo "Error: \"ln -s\" does not appear to work on this system!"
97            echo "  For help, please contact <MITgcm-support@mitgcm.org>."
98            exit 1
99      fi      fi
100      rm -f test link      rm -f test link
101    
102      p_CPP=`which cpp`      if test "x$CPP" = x ; then
103                CPP="cpp -traditional -P"
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         p_LN="ln -s"  
104      fi      fi
     rm -f test link  
105    
106      # look for possible fortran compilers      # look for possible fortran compilers
107        tmp="$MITGCM_FC $FC g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
108      p_FC=      p_FC=
109      for c in f77 g77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95 ; do      for c in $tmp ; do
110          which $c > /dev/null 2>&1          rm -f ./hello.f ./hello
111            cat >> hello.f <<EOF
112          program hello
113          do i=1,3
114            print *, 'hello world : ', i
115          enddo
116          end
117    EOF
118            $c -o hello hello.f > /dev/null 2>&1
119          RETVAL=$?          RETVAL=$?
120          if test "x${RETVAL}" = x0 ; then          if test "x${RETVAL}" = x0 ; then
121              p_FC="$p_FC $c"              p_FC="$p_FC $c"
122          fi          fi
123      done      done
     echo "Possible FORTRAN compilers appear to be:  "  
124      if test "x${p_FC}" = x ; then      if test "x${p_FC}" = x ; then
125          echo "  None found!!!"          cat 1>&2 <<EOF
126    
127    Error: No Fortran compilers were found in your path.  Please specify one using:
128    
129        1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
130        2) a command-line option (eg. "-fc NAME"), or
131        3) the MITGCM_FC environment variable.
132    
133    EOF
134            exit 1
135      else      else
136          echo "  "$p_FC          echo "  The possible FORTRAN compilers found in your path are:"
137            echo "   "$p_FC
138            if test "x$FC" = x ; then
139                FC=`echo $p_FC | awk '{print $1}'`
140            fi
141      fi      fi
142    
143      # look for possible MPI libraries      for i in $p_FC ; do
144      mpi_libs=          p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
145      mpi_fort=`which mpif77 2>/dev/null`          if test -r $p_OF ; then
146      RETVAL=$?              OPTFILE=$p_OF
147      if test "x${RETVAL}" = x0 ; then              echo "  The options file:  $p_OF"
148          cat >>test.f <<EOF              echo "    appears to match so we'll use it."
149        PROGRAM HELLO              break
       DO 10, I=1,10  
       PRINT *,'Hello World'  
    10 CONTINUE  
       STOP  
       END  
 EOF  
         eval "$mpi_fort -showme test.f > out"  
         RETVAL=$?  
         if test "x${RETVAL}" = x0 ; then  
             a=`cat out`  
             for i in $a ; do  
                 case $i in  
                     -*)  
                         mpi_libs="$mpi_libs $i" ;;  
                 esac  
             done  
             echo "The MPI libs appear to be:"  
             echo "  "$mpi_libs  
150          fi          fi
151          rm -f test.f out      done
152        if test "x$OPTFILE" = x ; then
153            cat 1>&2 <<EOF
154    
155    Error: No options file was found in:  $ROOTDIR/tools/build_options/
156      that matches this platform ("$PLATFORM") and the compilers found in
157      your path.  Please specify an "optfile" using:
158    
159        1) the command line (eg. "-optfile=path/to/OPTFILE"), or
160        2) the MITGCM_OF environment variable.
161    
162      If you need help, please contact the developers at <MITgcm-support@mitgcm.org>.
163    
164    EOF
165            exit 1
166      fi      fi
167        
168    #     # look for possible MPI libraries
169    #     mpi_libs=
170    #     mpi_fort=`which mpif77 2>/dev/null`
171    #     RETVAL=$?
172    #     if test "x${RETVAL}" = x0 ; then
173    #       cat >>test.f <<EOF
174    #       PROGRAM HELLO
175    #       DO 10, I=1,10
176    #       PRINT *,'Hello World'
177    #    10 CONTINUE
178    #       STOP
179    #       END
180    # EOF
181    #       eval "$mpi_fort -showme test.f > out"
182    #       RETVAL=$?
183    #       if test "x${RETVAL}" = x0 ; then
184    #           a=`cat out`
185    #           for i in $a ; do
186    #               case $i in
187    #                   -*)
188    #                       mpi_libs="$mpi_libs $i" ;;
189    #               esac
190    #           done
191    #           echo "The MPI libs appear to be:"
192    #           echo "  "$mpi_libs
193    #       fi
194    #       rm -f test.f out
195    #     fi
196    
197  }  }
198    
# Line 123  usage()  { Line 239  usage()  {
239      echo "      -disable=NAME | --disable=NAME"      echo "      -disable=NAME | --disable=NAME"
240      echo "    -enable NAME | --enable NAME"      echo "    -enable NAME | --enable NAME"
241      echo "      -enable=NAME | --enable=NAME"      echo "      -enable=NAME | --enable=NAME"
242        echo "    -standarddirs NAME | --standarddirs NAME"
243        echo "      -standarddirs=NAME | --standarddirs=NAME"
244      echo "    -noopt NAME | --noopt NAME"      echo "    -noopt NAME | --noopt NAME"
245      echo "      -noopt=NAME | --noopt=NAME"      echo "      -noopt=NAME | --noopt=NAME"
246  #    echo "    -cpp NAME | --cpp NAME"  #    echo "    -cpp NAME | --cpp NAME"
# Line 172  S64= Line 290  S64=
290  KPP=  KPP=
291  FC=  FC=
292  LINK=  LINK=
293    DEFINES="-DWORDLENGTH=4"
294  PACKAGES=  PACKAGES=
295  ENABLE=  ENABLE=
296  DISABLE=  DISABLE=
297  MAKEFILE=  MAKEFILE=
298  MAKEDEPEND=  MAKEDEPEND=
299  PDEPEND=  PDEPEND=
300  DUMPSTATE=f  DUMPSTATE=t
301  PDEFAULT=  PDEFAULT=
302  OPTFILE=  OPTFILE=
303  INCLUDES="-I."  INCLUDES="-I."
# Line 196  MODS= Line 315  MODS=
315  TOOLSDIR=  TOOLSDIR=
316  SOURCEDIRS=  SOURCEDIRS=
317  INCLUDEDIRS=  INCLUDEDIRS=
318    STANDARDDIRS=
319    
320  PWD=`pwd`  PWD=`pwd`
321  MAKE=make  MAKE=make
# Line 203  THISHOSTNAME=`hostname` Line 323  THISHOSTNAME=`hostname`
323  THISCWD=`pwd`  THISCWD=`pwd`
324  THISDATE=`date`  THISDATE=`date`
325  MACHINE=`uname -a`  MACHINE=`uname -a`
326    EXECUTABLE=
327    EXEHOOK=
328    EXEDIR=
329    PACKAGES_CONF=
330    IEEE=
331    if test "x$MITGCM_IEEE" != x ; then
332        IEEE=$MITGCM_IEEE
333    fi
334    
335    AUTODIFF_PKG_USED=f
336    AD_OPTFILE=
337    
338  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
339  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"
340  gm_s2="FC IEEE MPI JAM DUMPSTATE"  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"
341    
342  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
343  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
344  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
345  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"
346    gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
347    
348    #  The following are all related to adjoint/tangent-linear stuff
349    gm_s7="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF DIFF_FLAGS AD_TAMC_FLAGS AD_TAF_FLAGS"
350    gm_s8="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"
351    gm_s9=""
352    
353  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5"  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7 $gm_s8"
354    
355    
356  echo  echo
357  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
358  gm_local="./gm_local"  gm_local="genmake_local"
359    for i in . $MODS ; do
360        if test -r $i/$gm_local ; then
361            source $i/$gm_local
362            break
363        fi
364    done
365  echo -n "  getting local config information:  "  echo -n "  getting local config information:  "
366  if test -e $gm_local ; then  if test -e $gm_local ; then
367      echo "using $gm_local"      echo "using $gm_local"
# Line 240  fi Line 383  fi
383  #   n=$(( $n + 1 ))  #   n=$(( $n + 1 ))
384  #done  #done
385  #parse_options  #parse_options
   
386  ac_prev=  ac_prev=
387  for ac_option ; do  for ac_option ; do
388    
# Line 265  for ac_option ; do Line 407  for ac_option ; do
407          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
408              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
409                    
410            -adoptfile | --adoptfile | -ad | --ad)
411                ac_prev=AD_OPTFILE ;;
412            -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
413                AD_OPTFILE=$ac_optarg ;;
414            
415          -pdepend | --pdepend)          -pdepend | --pdepend)
416              ac_prev=PDEPEND ;;              ac_prev=PDEPEND ;;
417          -pdepend=* | --pdepend=*)          -pdepend=* | --pdepend=*)
# Line 310  for ac_option ; do Line 457  for ac_option ; do
457          -enable=* | --enable=*)          -enable=* | --enable=*)
458              ENABLE=$ac_optarg ;;              ENABLE=$ac_optarg ;;
459                    
460            -standarddirs | --standarddirs)
461                ac_prev=STANDARDDIRS ;;
462            -standarddirs=* | --standarddirs=*)
463                STANDARDDIRS=$ac_optarg ;;
464    
465          -noopt | --noopt)          -noopt | --noopt)
466              ac_prev=NOOPT ;;              ac_prev=NOOPT ;;
467          -noopt=* | --noopt=*)          -noopt=* | --noopt=*)
# Line 326  for ac_option ; do Line 478  for ac_option ; do
478              FC=$ac_optarg ;;              FC=$ac_optarg ;;
479                    
480          -ieee | --ieee)          -ieee | --ieee)
481              IEEE=1 ;;              IEEE=true ;;
482          -noieee | --noieee)          -noieee | --noieee)
483              IEEE=0 ;;              IEEE= ;;
484                    
485          -mpi | --mpi)          -mpi | --mpi)
486              MPI=1 ;;              MPI=true ;;
487          -nompi | --nompi)          -nompi | --nompi)
488              MPI=0 ;;              MPI= ;;
489                    
490          -jam | --jam)          -jam | --jam)
491              JAM=1 ;;              JAM=1 ;;
# Line 357  for ac_option ; do Line 509  for ac_option ; do
509            
510  done  done
511    
512    if test -f ./.genmakerc ; then
513        echo
514        echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
515        echo "  file.  This file format is no longer supported.  Please see:"
516        echo
517        echo "    http://mitgcm.org/devel_HOWTO/"
518        echo
519        echo "  for directions on how to setup and use the new \"genmake2\" input"
520        echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."
521        echo
522    fi
523    
524    if test "x${ROOTDIR}" = x ; then
525        if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
526            ROOTDIR=".."
527        else
528            for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
529                if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
530                    ROOTDIR=$d
531                    echo -n "Warning:  ROOTDIR was not specified but there appears to be"
532                    echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
533                    break
534                fi
535            done
536        fi
537    fi
538    if test "x${ROOTDIR}" = x ; then
539        echo "Error: Cannot determine ROOTDIR for MITgcm code."
540        echo "  Please specify a ROOTDIR using either an options "
541        echo "  file or a command-line option."
542        exit 1
543    fi
544    if test ! -d ${ROOTDIR} ; then
545        echo "Error: the specified ROOTDIR (\"$ROOTDIR\") does not exist!"
546        exit 1
547    fi
548    
549  echo "  getting OPTFILE information:  "  echo "  getting OPTFILE information:  "
550  if test "x${OPTFILE}" = x ; then  if test "x${OPTFILE}" = x ; then
551      echo "Warning: no OPTFILE specified so we'll look for possible settings"      if test "x$MITGCM_OF" = x ; then
552      printf "\n===  Searching for possible settings for OPTFILE  ===\n"          echo "Warning: no OPTFILE specified so we'll look for possible settings"
553      find_possible_configs          printf "\n===  Searching for possible settings for OPTFILE  ===\n"
554  else          find_possible_configs
     if test "x$OPTFILE" = xNONE ; then  
         echo "    OPTFILE=NONE so we'll try to use default settings"  
555      else      else
556          if test -f "$OPTFILE" -a -r "$OPTFILE" ; then          OPTFILE=$MITGCM_OF
557              echo "    using OPTFILE=\"$OPTFILE\""      fi
558              source "$OPTFILE"  fi
559              RETVAL=$?  if test "x$OPTFILE" != xNONE ; then
560              if test "x$RETVAL" != x0 ; then      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
561                  echo -n "Error: failed to source OPTFILE \"$OPTFILE\""          echo "    using OPTFILE=\"$OPTFILE\""
562                  echo "--please check that variable syntax is bash-compatible"          source "$OPTFILE"
563                  exit 1          RETVAL=$?
564              fi          if test "x$RETVAL" != x0 ; then
565              if test "x$DUMPSTATE" != xf ; then              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""
566                  cp -f $OPTFILE "gm_optfile"              echo "--please check that variable syntax is bash-compatible"
567              fi              exit 1
568          else          fi
569              echo "Error: can't read OPTFILE=\"$OPTFILE\""          if test "x$DUMPSTATE" != xf ; then
570                cp -f $OPTFILE "genmake_optfile"
571            fi
572        else
573            echo "Error: can't read OPTFILE=\"$OPTFILE\""
574            exit 1
575        fi
576    fi
577    
578    echo "  getting AD_OPTFILE information:  "
579    if test "x${AD_OPTFILE}" = x ; then
580        if test "x$MITGCM_AD_OF" = x ; then
581            AD_OPTFILE=$ROOTDIR/tools/adjoint_options/adjoint_default
582        else
583            AD_OPTFILE=$MITGCM_AD_OF
584        fi
585    fi
586    if test "x${AD_OPTFILE}" != xNONE ; then
587        if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
588            echo "    using AD_OPTFILE=\"$AD_OPTFILE\""
589            source "$AD_OPTFILE"
590            RETVAL=$?
591            if test "x$RETVAL" != x0 ; then
592                echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
593                echo "--please check that variable syntax is bash-compatible"
594              exit 1              exit 1
595          fi          fi
596            if test "x$DUMPSTATE" != xf ; then
597                cp -f $AD_OPTFILE "genmake_ad_optfile"
598            fi
599        else
600            echo "Error: can't read AD_OPTFILE=\"$AD_OPTFILE\""
601            exit 1
602      fi      fi
603  fi  fi
604    
605    #  Check that FC, LINK, CPP, and S64 are defined.  If not, complain
606    #  and abort!
607    if test "x$FC" = x ; then
608        cat <<EOF 1>&2
609    
610    Error: no Fortran compiler: please specify using one of the following:
611      1) within the options file ("FC=...") as specified by "-of=OPTFILE"
612      2) the "-fc=XXX" command-line option
613      3) the "./genmake_local" file
614    EOF
615        exit 1
616    fi
617    if test "x$LINK" = x ; then
618        LINK=$FC
619    fi
620    if test "x$CPP" = x ; then
621        CPP="cpp"
622    fi
623    echo "#define A a" | $CPP > test_cpp 2>&1
624    RETVAL=$?
625    if test "x$RETVAL" != x0 ; then
626        cat <<EOF 1>&2
627    
628    Error: C pre-processor "$CPP" failed the test case: please specify using:
629    
630      1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
631      2) the "./genmake_local" file
632    
633    EOF
634        exit 1
635    else
636        rm -f test_cpp
637    fi
638    if test "x$MAKEDEPEND" = x ; then
639        MAKEDEPEND=makedepend
640    fi
641    
642  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
643  echo -n "  Adding MODS directories:  "  echo -n "  Adding MODS directories:  "
644  for d in $MODS ; do  for d in $MODS ; do
# Line 407  if test "x${PLATFORM}" = x ; then Line 661  if test "x${PLATFORM}" = x ; then
661      PLATFORM=$p_PLATFORM      PLATFORM=$p_PLATFORM
662  fi  fi
663    
 if test "x${ROOTDIR}" = x ; then  
     if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then  
         ROOTDIR=".."  
     else  
         for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do  
             if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then  
                 ROOTDIR=$d  
                 echo -n "Warning:  ROOTDIR was not specified but there appears to be"  
                 echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."  
                 break  
             fi  
         done  
     fi  
 fi  
 if test "x${ROOTDIR}" = x ; then  
     echo "Error: Cannot determine ROOTDIR for MITgcm code."  
     echo "  Please specify a ROOTDIR using either an options "  
     echo "  file or a command-line option."  
     exit 1  
 fi  
 if test ! -d ${ROOTDIR} ; then  
     echo "Error: the specified ROOTDIR (\"$ROOTDIR\") does not exist!"  
     exit 1  
 fi  
   
664  if test "x${EXEDIR}" = x ; then  if test "x${EXEDIR}" = x ; then
665      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then
666          EXEDIR=../exe          EXEDIR=../exe
# Line 451  if test ! -d ${TOOLSDIR} ; then Line 680  if test ! -d ${TOOLSDIR} ; then
680      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"
681      exit 1      exit 1
682  fi  fi
683    if test "x$S64" = x ; then
684        S64='$(TOOLSDIR)/set64bitConst.sh'
685    fi
686    
687  EXECUTABLE=${EXECUTABLE:-mitgcmuv}  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
688    
# Line 499  fi Line 731  fi
731  source ./.pd_tmp  source ./.pd_tmp
732  rm -f ./.pd_tmp  rm -f ./.pd_tmp
733    
734    #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"
735    #  file should eventually be added so that, for convenience, one can
736    #  specify groups of packages using names like "ocean" and "atmosphere".
737  echo  -n "  checking default package list:  "  echo  -n "  checking default package list:  "
738  if test "x${PDEFAULT}" = x ; then  if test "x${PDEFAULT}" = x ; then
739        for i in "." $MODS ; do
740            if test -r $i"/packages.conf" ; then
741                    PDEFAULT=$i"/packages.conf"
742                    break
743            fi
744        done
745    fi
746    if test "x${PDEFAULT}" = x ; then
747      PDEFAULT="$ROOTDIR/pkg/pkg_default"      PDEFAULT="$ROOTDIR/pkg/pkg_default"
748  fi  fi
749  if test "x${PDEFAULT}" = xNONE ; then  if test "x${PDEFAULT}" = xNONE ; then
# Line 522  else Line 765  else
765          for i in $def ; do          for i in $def ; do
766              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
767          done          done
768          echo "    packages are:  $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
769            expand_pkg_groups
770            echo "    after group expansion packages are:  $PACKAGES"
771      fi      fi
772  fi  fi
773    
# Line 541  for p in $PACKAGES ; do Line 786  for p in $PACKAGES ; do
786  done  done
787  PACKAGES="$pack"  PACKAGES="$pack"
788  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
789  rm -f ./.tmp_pack  echo "" > ./.tmp_pack
790  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
791  for i in $PACKAGES ; do  for i in $PACKAGES ; do
792      if test ! -d "$ROOTDIR/pkg/$i" ; then      if test ! -d "$ROOTDIR/pkg/$i" ; then
# Line 632  for i in $PACKAGES ; do Line 877  for i in $PACKAGES ; do
877      if test -d $adr ; then      if test -d $adr ; then
878          SOURCEDIRS="$SOURCEDIRS $adr"          SOURCEDIRS="$SOURCEDIRS $adr"
879          INCLUDEDIRS="$INCLUDEDIRS $adr"          INCLUDEDIRS="$INCLUDEDIRS $adr"
880            if test "x$i" = xautodiff ; then
881                AUTODIFF_PKG_USED=t
882            fi
883      else      else
884          echo "Error: the directory \"$adr\" for package $i doesn't exist"          echo "Error: the directory \"$adr\" for package $i doesn't exist"
885          exit 1          exit 1
# Line 657  done Line 905  done
905  # done  # done
906  # echo  # echo
907    
908  echo "  Setting package-specific CPP flags in CPP_OPTIONS.h:"  # Create a list of #define and #undef to enable/disable packages
909  CPP_OPTIONS=  PACKAGES_DOT_H=PACKAGES_CONFIG.h
910  spaths="$SOURCEDIRS"  cat <<EOF >$PACKAGES_DOT_H".tmp"
 for i in $spaths ; do  
     try="$i/CPP_OPTIONS.h"  
     #  echo -n "    trying $try : "  
     if test -f $try -a -r $try ; then  
         echo "    found CPP_OPTIONS=\"$try\""  
         CPP_OPTIONS="$try"  
         if test "x$i" != "x." ; then  
             cp -f $CPP_OPTIONS .  
         fi  
         break  
     fi  
 done  
 if test "x$CPP_OPTIONS" = x ; then  
     echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"  
     exit 1  
 fi  
 if test -e CPP_OPTIONS.h ; then  
     if test ! -e CPP_OPTIONS.h.bak ; then  
         cp -f CPP_OPTIONS.h CPP_OPTIONS.h.bak  
     fi  
     cat CPP_OPTIONS.h \  
         | awk 'BEGIN{p=1;} ($1=="C===" && $2=="GENMAKE"){p=0;} {if (p==1) print $0}' \  
         > CPP_OPTIONS.h.tmp  
 fi  
 cat <<EOF >>CPP_OPTIONS.h.tmp  
911  C=== GENMAKE v2 ===  C=== GENMAKE v2 ===
912  C  The following defines have been set by GENMAKE, so please edit  C  The following defines have been set by GENMAKE, so please do not
913  C  them only if you know what you're doing.  In general, you should  C  edit anything below these comments.  In general, you should
914  C  add or remove packages by re-running genmake with different  C  add or remove packages by re-running genmake with different
915  C  "-enable" and/or "-disable" options.  C  "-enable" and/or "-disable" options.
916    
917    #ifndef PACKAGES_H
918    #define PACKAGES_H
919    
920  C  Packages disabled by genmake:  C  Packages disabled by genmake:
921  EOF  EOF
922  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
# Line 710  for n in $names ; do Line 936  for n in $names ; do
936          done          done
937          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
938              undef=`echo "ALLOW_$n" | awk '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | awk '{print toupper($0)}'`
939              echo "#undef $undef" >> CPP_OPTIONS.h.tmp              echo "#undef $undef" >> $PACKAGES_DOT_H".tmp"
940    #           DEFINES="$DEFINES -U$undef"
941    
942  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
943              case $n in              case $n in
# Line 720  for n in $names ; do Line 947  for n in $names ; do
947                  mom_vecinv)                  mom_vecinv)
948                      DEFINES="$DEFINES -DDISABLE_MOM_VECINV"                      DEFINES="$DEFINES -DDISABLE_MOM_VECINV"
949                      ;;                      ;;
                 generic_advdiff)  
                     DEFINES="$DEFINES -DDISABLE_GENERIC_ADVDIFF"  
                     ;;  
950                  debug)                  debug)
951                      DEFINES="$DEFINES -DDISABLE_DEBUGMODE"                      DEFINES="$DEFINES -DDISABLE_DEBUGMODE"
952                      ;;                      ;;
# Line 732  for n in $names ; do Line 956  for n in $names ; do
956          fi          fi
957      fi      fi
958  done  done
959  cat <<EOF >>CPP_OPTIONS.h.tmp  cat <<EOF >>$PACKAGES_DOT_H".tmp"
960    
961  C  Packages enabled by genmake:  C  Packages enabled by genmake:
962  EOF  EOF
963  for i in $PACKAGES ; do  for i in $PACKAGES ; do
964      def=`echo "ALLOW_$i" | awk '{print toupper($0)}'`      def=`echo "ALLOW_$i" | awk '{print toupper($0)}'`
965      echo "#define $def" >> CPP_OPTIONS.h.tmp      echo "#define $def" >> $PACKAGES_DOT_H".tmp"
966    #eh3 DEFINES="$DEFINES -D$def"
967    
968  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
969      case $i in      case $i in
970          aim_v23)          aim_v23)
971              echo "#define   ALLOW_AIM" >> CPP_OPTIONS.h.tmp              echo "#define   ALLOW_AIM" >> $PACKAGES_DOT_H".tmp"
972                DEFINES="$DEFINES -DALLOW_AIM"
973                echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"
974              ;;              ;;
975      esac      esac
976  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
977    
978  done  done
979  mv -f CPP_OPTIONS.h.tmp CPP_OPTIONS.h  cat <<EOF >>$PACKAGES_DOT_H".tmp"
980    
981    #endif /* PACKAGES_H */
982    EOF
983    
984    if test ! -f $PACKAGES_DOT_H ; then
985        mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
986    else
987        cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
988        RETVAL=$?
989        if test "x$RETVAL" = x0 ; then
990            rm -f $PACKAGES_DOT_H".tmp"
991        else
992            mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
993            mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
994        fi
995    fi
996    
997  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
998  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
999  STANDARDDIRS=${STANDARDDIRS:-"eesupp model"}  if test "x$STANDARDDIRS" = x ; then
1000        STANDARDDIRS="eesupp model"
1001    fi
1002  for d in $STANDARDDIRS ; do  for d in $STANDARDDIRS ; do
1003      adr="$ROOTDIR/$d/src"      adr="$ROOTDIR/$d/src"
1004      if test ! -d $adr ; then      if test ! -d $adr ; then
# Line 773  for d in $STANDARDDIRS ; do Line 1018  for d in $STANDARDDIRS ; do
1018      fi      fi
1019  done  done
1020    
1021    echo " Searching for CPP_OPTIONS.h in order to warn about the presence"
1022    echo " of \"#define ALLOW_PKGNAME\"-type statements:"
1023    CPP_OPTIONS=
1024    spaths=". $INCLUDEDIRS"
1025    for i in $spaths ; do
1026        try="$i/CPP_OPTIONS.h"
1027        #  echo -n "    trying $try : "
1028        if test -f $try -a -r $try ; then
1029            echo "    found CPP_OPTIONS=\"$try\""
1030            CPP_OPTIONS="$try"
1031            break
1032        fi
1033    done
1034    if test "x$CPP_OPTIONS" = x ; then
1035        echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1036        exit 1
1037    fi
1038    # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1039    names=`ls -1 "$ROOTDIR/pkg"`
1040    for n in $names ; do
1041        test_for_package_in_cpp_options $CPP_OPTIONS $n
1042    done
1043    
1044    
1045    #  Here, we build the list of files to be "run through" the adjoint
1046    #  compiler.
1047    if test -f ./ad_files ; then
1048        rm -f ./ad_files
1049    fi
1050    echo "  Creating the list of files for the adjoint compiler."
1051    for i in $SOURCEDIRS ; do
1052        list_files=`( cd $i && ls -1 *.list 2>/dev/null )`
1053        for j in $list_files ; do
1054            cat $i/$j >> ad_files
1055        done
1056    done
1057    
1058    cat <<EOF > adjoint_sed
1059    s/call adopen(/call adopen ( mythid,\\
1060         \&           /g
1061    s/call adclose(/call adclose( mythid,\\
1062         \&           /g
1063    s/call adread(/call adread ( mythid,\\
1064         \&           /g
1065    s/call adwrite(/call adwrite( mythid,\\
1066         \&           /g
1067    
1068    EOF
1069    
1070  echo  echo
1071  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1072  echo "  setting INCLUDES"  echo "  setting INCLUDES"
1073  for i in $INCLUDEDIRS ; do  for i in $INCLUDEDIRS ; do
1074      if test -d $i ; then      if ! test -d $i ; then
1075          INCLUDES="$INCLUDES -I$i"  #       INCLUDES="$INCLUDES -I$i"
1076      else  #   else
1077          echo "Warning: can't find INCLUDEDIRS=\"$i\""          echo "Warning: can't find INCLUDEDIRS=\"$i\""
1078      fi      fi
1079  done  done
# Line 794  echo -n 'SRCFILES = '    > srclist.inc Line 1087  echo -n 'SRCFILES = '    > srclist.inc
1087  echo -n 'CSRCFILES = '   > csrclist.inc  echo -n 'CSRCFILES = '   > csrclist.inc
1088  echo -n 'F90SRCFILES = ' > f90srclist.inc  echo -n 'F90SRCFILES = ' > f90srclist.inc
1089  echo -n 'HEADERFILES = ' > hlist.inc  echo -n 'HEADERFILES = ' > hlist.inc
1090  alldirs=". $SOURCEDIRS $INCLUDEDIRS"  echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc
1091    alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1092  for d in $alldirs ; do  for d in $alldirs ; do
1093      deplist=      deplist=
1094      sfiles=`( cd $d; echo *.[h,c,F] )`      sfiles=`( cd $d; echo *.[h,c,F] *.flow )`
1095      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`
1096      for sf in $sfiles ; do      for sf in $sfiles ; do
1097          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
# Line 822  for d in $alldirs ; do Line 1116  for d in $alldirs ; do
1116                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1117                          echo -n " $sf" >> hlist.inc                          echo -n " $sf" >> hlist.inc
1118                          ;;                          ;;
1119                        flow)
1120                            echo    " \\"  >> ad_flow_files.inc
1121                            echo -n " $sf" >> ad_flow_files.inc
1122                            ;;
1123                  esac                  esac
1124              fi              fi
1125          fi          fi
# Line 838  echo "" >> srclist.inc Line 1136  echo "" >> srclist.inc
1136  echo "" >> csrclist.inc  echo "" >> csrclist.inc
1137  echo "" >> f90srclist.inc  echo "" >> f90srclist.inc
1138  echo "" >> hlist.inc  echo "" >> hlist.inc
1139    echo "" >> ad_flow_files.inc
1140    
1141  if test -e $MAKEFILE ; then  if test -e $MAKEFILE ; then
1142      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
# Line 879  EXEDIR      = ${EXEDIR} Line 1178  EXEDIR      = ${EXEDIR}
1178  EXECUTABLE  = \$(EXEDIR)/${EXECUTABLE}  EXECUTABLE  = \$(EXEDIR)/${EXECUTABLE}
1179  TOOLSDIR    = ${TOOLSDIR}  TOOLSDIR    = ${TOOLSDIR}
1180    
1181    #eh3  new defines for the adjoint work
1182    AUTODIFF    = ${ROOTDIR}/pkg/autodiff
1183    
1184  EOF  EOF
1185    
1186  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 924  MAKEFILE=${MAKEFILE} Line 1226  MAKEFILE=${MAKEFILE}
1226    
1227  EOF  EOF
1228    
1229  cat srclist.inc    >> $MAKEFILE  cat srclist.inc       >> $MAKEFILE
1230  cat csrclist.inc   >> $MAKEFILE  cat csrclist.inc      >> $MAKEFILE
1231  cat f90srclist.inc >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
1232  cat hlist.inc      >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
1233    cat ad_flow_files.inc >> $MAKEFILE
1234    echo               >> $MAKEFILE
1235  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE
1236  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE
1237  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1238    
1239  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1240    rm -f ad_flow_files.inc
1241    
1242  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1243    
# Line 945  all: \$(EXECUTABLE) Line 1250  all: \$(EXECUTABLE)
1250  depend:  depend:
1251          @make links          @make links
1252          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1253          ../../../tools/f90mkdepend >> \$(MAKEFILE)          ${TOOLSDIR}/f90mkdepend >> \$(MAKEFILE)
1254    
1255  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)
1256    
# Line 960  clean: Line 1265  clean:
1265  Clean:  Clean:
1266          @make clean          @make clean
1267          @make cleanlinks          @make cleanlinks
1268          -rm -f Makefile.bak          -rm -f Makefile.bak genmake_state genmake_optfile make.log
1269  CLEAN:  CLEAN:
1270          @make Clean          @make Clean
1271          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
1272          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
1273          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1274          -rm -f \$(EXECUTABLE)          -rm -f \$(EXECUTABLE) output.txt
1275    
1276    Makefile: makefile
1277  makefile:  makefile:
1278          ${0} $@          ${0} $@
1279  cleanlinks:  cleanlinks:
# Line 991  cleanlinks: Line 1297  cleanlinks:
1297  .p.f:  .p.f:
1298          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
1299    
1300    #=========================================
1301    #===  Automatic Differentiation Rules  ===
1302    
1303    TAMC           = ${TAMC}
1304    TAF            = ${TAF}
1305    
1306    EOF
1307    
1308    ad_vars="AD_TAMC_FLAGS AD_TAF_FLAGS"
1309    ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF_FLAGS"
1310    ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
1311    for i in $ad_vars ; do
1312        name=$i
1313        t1="t2=\$"`echo $i`
1314        eval $t1
1315        printf "%-20s = " $name >> $MAKEFILE
1316        echo $t2 >> $MAKEFILE
1317    done
1318    
1319    echo "  Add the source list for AD code generation"
1320    echo >> $MAKEFILE
1321    echo -n "AD_FILES = " >> $MAKEFILE
1322    AD_FILES=`cat ad_files`
1323    for i in $AD_FILES ; do
1324        echo    " \\" >> $MAKEFILE
1325        echo -n " $i" >> $MAKEFILE
1326    done
1327    echo >> $MAKEFILE
1328    
1329    cat >>$MAKEFILE <<EOF
1330    
1331    
1332    ad_input_code.f: \$(F77FILES)
1333            @make \$(AD_FLOW_FILES)
1334            cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
1335    
1336    
1337    ad_taf_output.f: ad_input_code.f
1338            \$(TAF) \$(AD_TAF_FLAGS) ad_input_code.f
1339            cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f
1340    
1341    ad_taf: ad_taf_output.o \$(OBJFILES)
1342            \$(LINK) -o ${EXECUTABLE} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
1343    
1344    
1345    ad_tamc_output.f: ad_input_code.f
1346            \$(TAMC) \$(AD_TAMC_FLAGS) ad_input_code.f
1347            cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f
1348    
1349    ad_tamc: ad_tamc_output.o \$(OBJFILES)
1350            \$(LINK) -o ${EXECUTABLE} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
1351    
1352    
1353    flt_taf_output.f: ad_input_code.f
1354            \$(TAF) \$(FTL_TAF_FLAGS) ad_input_code.f
1355            cat ad_input_code_ad.f | sed -f adjoint_sed > flt_taf_output.f
1356    
1357    flt_taf: flt_taf_output.o \$(OBJFILES)
1358            \$(LINK) -o ${EXECUTABLE} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) flt_taf_output.o \$(LIBS)
1359    
1360    
1361    
1362    #=========================================
1363    
1364  EOF  EOF
1365    
1366    if test "x$EXEHOOK" != x ; then
1367        printf "\nexehook:\n\t%s\n" $EXEHOOK >> $MAKEFILE
1368    fi
1369    
1370  echo "  Making list of \"exceptions\" that need \".p\" files"  echo "  Making list of \"exceptions\" that need \".p\" files"
1371  for i in $KPPFILES ; do  for i in $KPPFILES ; do
1372      base=`echo $i | sed -e 's/\/.*\///g' | sed -e 's/\..*$//g'`      base=`echo $i | sed -e 's/\/.*\///g' | sed -e 's/\..*$//g'`
# Line 1026  printf "\n===  Done  ===\n" Line 1400  printf "\n===  Done  ===\n"
1400    
1401  #  Write the "state" for future records  #  Write the "state" for future records
1402  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
1403      echo -n "" > gm_state      echo -n "" > genmake_state
1404      for i in $gm_state ; do      for i in $gm_state ; do
1405          t1="t2=\$$i"          t1="t2=\$$i"
1406          eval $t1          eval $t1
1407          echo "$i='$t2'" >> gm_state          echo "$i='$t2'" >> genmake_state
1408      done      done
1409  fi  fi

Legend:
Removed from v.1.6  
changed lines
  Added in v.1.14

  ViewVC Help
Powered by ViewVC 1.1.22